// OCL - Class Library for OS/2 2.x and up
// (c) Benjamin Stein 1994
// All Rights Reserved
// OApp.hpp


#ifndef OAPP_INCLUDED
  #define OAPP_INCLUDED


#ifndef OPMINIT_INCLUDED
  #include <opminit.hpp>
#endif

#ifndef OAPPBASE_INCLUDED
  #include <OAppBase.hpp>
#endif

#ifndef OCOMMAND_INCLUDED
  #include <OCommand.hpp>
#endif


// classes


typedef class OApp *pOApp;

class __CPP_EXPORT__ OApp : public OAppBase, public OPMinit
{
 private:
   OCommandHandler OCMD_NullHandler;

 public:
   static pOApp currentOApp;

   OApp(ULONG queueSize = 10);      
   OApp(const ULONG num, CHAR *Parms[], ULONG queueSize = 10);

   virtual ~OApp();

   virtual void run();              // enhanced message loop
   virtual BOOL QuitPosted();       // a window posted a quit message,  default is ret FALSE = to quit
   virtual BOOL TasklistKill();     // user tried to close a window from the tasklist,  default is ret FALSE = to quit
   virtual BOOL ShutdownPosted();   // system posted shutdown-message,  default is ret FALSE = to quit

   pOCommandHandler NullHandler();

   // although public this function is for internal use only and must not be used !!
 
   static BOOL OCMDTrace(const HWND hwnd,
                         const ULONG msg,
                         const MPARAM mp1, 
                         const MPARAM mp2);

// overloaded from OAppBase

   virtual void forceQuit();        // force OApp::run() to return
   virtual void Shutdown();
   virtual void Reboot();
};


#endif // OAPP_INCLUDED


// end of source
