// OCL - Class Library for OS/2 2.x and up
// (c) Benjamin Stein 1994
// All Rights Reserved
// OAppBase.hpp


#ifndef OAPPBASE_INCLUDED
  #define OAPPBASE_INCLUDED

#ifndef OSTRING_INCLUDED
  #include <OString.hpp>
#endif

#ifndef LIST_INCLUDED
  #include <OList.hpp>
#endif

#ifndef LOSTRING_INCLUDED
  #include <lOString.hpp>
#endif


typedef class OAppBase *pOAppBase;

class __CPP_EXPORT__ OAppBase 
{
 public:
   OString   callName;
   lOString  args;

   OAppBase();
   OAppBase(const ULONG num, CHAR *Parms[]);
   virtual ~OAppBase();

   void saveArgs(const ULONG num, CHAR *Parms[]);
   virtual void initArgs(PCSZ argStr);  // does nothing by default


   void SyncDisks();             // write caches to disk

   virtual void forceQuit() = 0;
   virtual void Shutdown() = 0;
   virtual void Reboot() = 0;
};


#endif // OAPPBASE_INCLUDED


// end of source
