// OCL - Class Library for OS/2 2.x and up
// (c) Benjamin Stein 1994
// All Rights Reserved
// OBook.hpp  - Notebooks


#ifndef OBOOK_INCLUDED
  #define OBOOK_INCLUDED


#ifndef OFRAME_INCLUDED
  #include <OFrame.hpp>
#endif

#ifndef LIST_INCLUDED
  #include <OList.hpp>
#endif


// definitions and macros

// this is a standard style configuration
// use your own if you want

#define NB_STANDARD  (BKS_BACKPAGESBR | BKS_MAJORTABRIGHT | BKS_ROUNDEDTABS | BKS_STATUSTEXTLEFT | \
                      BKS_SPIRALBIND | BKS_TABTEXTLEFT | WS_GROUP | WS_TABSTOP | WS_VISIBLE)

#define NB_STANDARD_FRAME (FCF_TASKLIST | FCF_TITLEBAR | FCF_SYSMENU | \
                           FCF_MINBUTTON | FCF_SIZEBORDER | FCF_ICON)



// setup for a particular notebook page

typedef struct NBPAGE *PNBPAGE;

struct NBPAGE
{
 PSZ              szStatusLineText;
 PSZ              szTabText;
 ULONG            idDlg;
 ULONG            idFocus;
 BOOL             fParent;
 USHORT           usTabType;
 ULONG            ulPageID;
 pOCommandHandler cmd;
};
typedef List<NBPAGE> pageList;
typedef pageList *ppageList;



typedef class OBook *pOBook;

class __CPP_EXPORT__ OBook : public OFrame
{
 private:  // these private members are strictly for internal use only !!!
   void  NBError(PCH msg);
   HWND  Assoc(PNBPAGE pnbp, PPAGESELECTNOTIFY ppsn);
   BOOL  sP(PNBPAGE pP);
   ULONG gSS(PCSZ szString);
   void  sNBP(PPAGESELECTNOTIFY ppsn);
   BOOL  cNbk();

 public:
   HWND     book;      // notebook window handle
   pageList Pages;     // the pages setups in a List of pages
   ULONG    bStyle;    // Notebook Style
   ULONG    dimCX;     // cx-dimension
   ULONG    dimCY;     // cy-dimension

// ctors

   OBook(const ULONG id, 
         const HWND  Parent = HWND_DESKTOP,
         const ULONG frameStyle = NB_STANDARD_FRAME);

   OBook(const OFrame& Parent, 
         const ULONG frameStyle = NB_STANDARD_FRAME);

   OBook(const pOFrame Parent, 
         const ULONG frameStyle = NB_STANDARD_FRAME);

// dtor
   virtual ~OBook();

// public methods

   BOOL createBook(PCSZ Text, const ULONG cx, const ULONG cy, const ULONG bookStyle);
   void setFramePos() { setSizePosFrame(HWND_TOP, sizepos, 0); }
   void setSizePosFrame(const HWND behind, SWP dimensions, const ULONG flags);
   BOOL addPages(ppageList pagesList);
   BOOL setTabDimensions();

// command Handlers
   virtual BOOL OCommand(ULONG msg, MPARAM mp1, MPARAM mp2);
};



#endif // OBOOK_INCLUDED

// end of source
