// OCL - Class Library for OS/2 2.x and up
// (c) Benjamin Stein 1994
// All Rights Reserved
// OCL.HPP

#define __OCL__
#define OCL_HPP_INCLUDED

#ifdef INCL_OCL
  #define OINCL_BASE
  #define OINCL_GRAPHICS
  #define OINCL_OVIOEXCEPTION
  #define OINCL_OPMEXCEPTION
  #define OINCL_OXCPTPM
  #define OINCL_OPMINIT
  #define OINCL_OAPP
  #define OINCL_OVIOAPP
  #define OINCL_OVIOHLP
  #define OINCL_OCOMMAND
  #define OINCL_OWINDOW
  #define OINCL_OFRAME
  #define OINCL_OBOOK
  #define OINCL_FCL
  #define OINCL_OTHREAD
  #define OINCL_OPROFILE
  #define OINCL_OSYSINFO
  #define OINCL_ODIALOG
  #define OINCL_OCREATE
  #define OINCL_ONPIPE
  #define OINCL_OMLE
  #define OINCL_OEDITOR
  #define OINCL_OMSGS
  #define OINCL_ONSEM
  #define OINCL_OSTATLINE
  #define OINCL_OBUTTONBAR
  #define OINCL_OLOGO
  #define OINCL_OHELP
  #define OINCL_OCONTAINER
  #define OINCL_OSLIDER
  #define OINCL_OCIRCSLIDER
  #define OINCL_OSPINBUTTON
  #define OINCL_OINDICATOR
  #define OINCL_OVALUESET
  #define OINCL_OENTRYFIELD
  #define OINCL_OLISTBOX
#endif

#ifdef OINCL_GRAPHICS
  #define OINCL_OICON
  #define OINCL_OBITMAP
#endif

#ifdef INCL_VIOOCL
  #define __OCL_NO_PM__
  #define OINCL_XCPT
  #define OINCL_OVIOAPP
  #define OINCL_FCL
  #define OINCL_OTHREAD
  #define OINCL_OSYSINFOVIO
  #define OINCL_OCREATE
  #define OINCL_OPIPE
  #define OINCL_ONSEM
  #define OINCL_OMUXSEM
  #define OINCL_OMUXWAITSEM
#endif

#ifndef OINLC_OAPP
 #define INCL_WIN
 #define INCL_PM
 #define OINCL_XCPT
#endif

#ifdef OINCL_FCL
 #define OINCL_XCPT
 #define INCL_DOS
#endif

#ifdef OINCL_XCPT
 #define INCL_DOSEXCEPTIONS
#endif

#define INCL_DOSPROCESS
#define INCL_DOSERRORS
#define INCL_DOSSESMGR

// Die common includes nehmen sich an dieser Stelle nicht
// besonders glcklich aus, stehen hier jedoch nicht ohne
// Grund. Einige Standard-Funktionen fr strcpy() oder
// memset() etc. sind in den CPP-Headern des CSet als
// inline functions gemappt.
// Die OCL System Exception Handler (OXCPTPM bzw. OXCPTVIO)
// funktionieren seltsamerweise nur, wenn diese gemappten
// Funktionen vor den OXCPT-Headern included werden.
// Nebeneffekt: Es tut der Bequemlichkeit gut.

#ifdef __BCPLUSPLUS__
  #include <string.h>
  typedef const char *PCSZ;
#endif

#include <os2.h>
#include <stddef.h>
#include <bsedos.h>
#include <stdlib.h>
#include <process.h>
#include <stdio.h>
#include <bsedev.h>
#include <iostream.h>
#include <fstream.h>

#ifdef __BUILD_OCL_DLL__
# ifdef __IBMCPP__
#   define __CPP_EXPORT__ _Export
# endif
# if (defined (__WATCOM_CPLUSPLUS__) || defined (__BCPLUSPLUS__))
#   define __CPP_EXPORT__ __export
# endif
#else
# define __CPP_EXPORT__
#endif


#if (defined ( OINCL_OSTRING ) || defined ( OINCL_BASE ))
 #include <OString.hpp>
#endif

#if (defined ( OINCL_LIST ) || defined ( OINCL_BASE ))
 #include <OList.hpp>
#endif

#ifdef OINCL_OVIOEXCEPTION
  #include <OVioException.hpp>
#endif

#ifdef OINCL_OPMEXCEPTION
  #include <OPMException.hpp>
#endif

#ifdef OINCL_SORTEDLIST
  #include <OSortedList.hpp>
#endif

#ifdef OINCL_OXCPTVIO
  #include <OXcptVio.hpp>
#endif

#ifdef OINCL_OXCPTPM
  #include <OXcptPM.hpp>
#endif

#ifdef OINCL_OSTRING
  #include <OString.hpp>
#endif

#ifdef OINCL_OPMINIT
  #include <OPMinit.hpp>
#endif

#ifdef OINCL_OCOMMAND
  #include <OCommand.hpp>
#endif

#ifdef OINCL_OVIOAPP
  #include <OVioApp.hpp>
#endif

#ifdef OINCL_OAPP
  #include <OApp.hpp>
#endif

#ifdef OINCL_FCL
  #include <OFcl.hpp>
#endif

#ifdef OINCL_OCREATE
  #include <OCreate.hpp>
#endif

#ifdef OINCL_OWINDOW
  #include <OWindow.hpp>
#endif

#ifdef OINCL_OFRAME
  #include <OFrame.hpp>
#endif

#ifdef OINCL_OBOOK
  #include <OBook.hpp>
#endif

#ifdef OINCL_OTHREAD
  #include <OThread.hpp>
#endif

#ifdef OINCL_OPROFILE
  #include <OProfile.hpp>
#endif

#ifdef OINCL_OSYSINFO
  #include <OSysInfo.hpp>
#endif

#ifdef OINCL_OSYSINFOVIO
  #include <OSysInfo.hpp>
#endif

#ifdef OINCL_OPROCSTAT
  #include <OSystem.hpp>
#endif

#ifdef OINCL_ODIALOG
  #include <ODialog.hpp>
#endif

#ifdef OINCL_ONSEM
  #include <ONSem.hpp>
#endif

#ifdef OINCL_ONPIPE
  #include <ONPipe.hpp>
#endif

#ifdef OINCL_OMLE
  #include <OMLE.hpp>
#endif

#ifdef OINCL_OEDITOR
  #include <OEditor.hpp>
#endif


#ifdef OINCL_OMSGS
  #include <OMSGS.hpp>
#endif

#ifdef OINCL_OSTATLINE
  #include <OStatusLine.hpp>
#endif

#ifdef OINCL_OBUTTONBAR
  #include <OButtonBar.hpp>
#endif

#ifdef OINCL_OLOGO
  #include <OLogo.hpp>
#endif

#ifdef OINCL_OHELP
  #include <OHelp.hpp>
#endif

#ifdef OINCL_OCONTAINER
  #include <OContainer.hpp>
#endif

#ifdef OINCL_OSLIDER
  #include <OSlider.hpp>
#endif

#ifdef OINCL_OCIRCSLIDER
  #include <OCircSlider.hpp>
#endif

#ifdef OINCL_OINDICATOR
  #include <OIndicator.hpp>
#endif

#ifdef OINCL_OSPINBUTTON
  #include <OSpinBtn.hpp>
#endif

#ifdef OINCL_OVALUESET
  #include <OValueSet.hpp>
#endif

#ifdef OINCL_OENTRYFIELD
  #include <OEntryField.hpp>
#endif

#ifdef OINCL_OLISTBOX
  #include <OListBox.hpp>
#endif


#ifdef OINCL_OICON
  #include <OIcon.hpp>
#endif


#ifdef OINCL_OBITMAP
  #include <OBitmap.hpp>
#endif


#ifdef OINCL_OMUXSEM
  #include <OMuxSem.hpp>
#endif

#ifdef OINCL_OMUXWAITSEM
  #include <OMuxWaitSem.hpp>
#endif

#ifndef OCL_INCLUDED
  #define OCL_INCLUDED

#ifdef __DEBUG_ALLOC__

class __CPP_EXPORT__ MemoryChecker
{
 public:
    MemoryChecker() {}
    ~MemoryChecker() {
       _dump_allocated(-1); }
};

extern MemoryChecker memCheck;

#endif // __DEBUG_ALLOC__


// einige ntzliche in C implementierte Funktionen ...

#ifdef __cplusplus
  extern "C" {
#endif


PSZ __CPP_EXPORT__ OCLVersion(void);

BOOL __CPP_EXPORT__ SaveID(PCH Desk);

VOID __CPP_EXPORT__ ShowDialogItem(HWND hwnd,
                                   USHORT usDialogIDs[],
                                   USHORT usItemCount);

VOID __CPP_EXPORT__ HideDialogItem(HWND hwnd,
                                   USHORT usDialogIDs[],
                                   USHORT usItemCount);

VOID __CPP_EXPORT__ DisableDialogItem(HWND hwnd,
                                      USHORT usDialogIDs[],
                                      USHORT usItemCount,
                                      ULONG ulStyle);

void __CPP_EXPORT__ disableControls(HWND hwnd, 
                                    USHORT usDialogIDs[], 
                                    ULONG count);

void __CPP_EXPORT__ enableControls(HWND hwnd, 
                                   USHORT usDialogIDs[], 
                                   ULONG count);

void __CPP_EXPORT__ hideControls(HWND hwnd, 
                                 USHORT usDialogIDs[], 
                                 ULONG count);

void __CPP_EXPORT__ showControls(HWND hwnd, 
                                 USHORT usDialogIDs[], 
                                 ULONG count);

APIRET __CPP_EXPORT__ StartSession(STARTDATA *SessionData);


#ifdef __cplusplus
  }
#endif

#ifndef __OCL_NO_PM__


#endif  // __OCL_NO_PM__


#endif // OCL_INCLUDED


// end of source  
