// OCL - Class Library for OS/2 2.x and up
// (c) Benjamin Stein 1994
// All Rights Reserved
// OEditor.hpp

#ifndef OEDITOR_INCLUDED
  #define OEDITOR_INCLUDED


#ifndef OMLE_INCLUDED
  #include <omle.hpp>
#endif


#ifndef OTHREAD_INLCUDED
  #include <OThread.hpp>
#endif



typedef class OEditor *pOEditor;

typedef OThread<OEditor> EditorThread;

class __CPP_EXPORT__ OEditor : public OMLE
{
 public:
   EditorThread  loadFileThr;
   EditorThread  saveFileThr;
   EditorThread  saveFileAsThr;
   BOOL          clearFlag;

// ctor/dtor

   OEditor(const ULONG id, 
           const HWND  Parent,
           const ULONG Style = OMLE::hscroll | OMLE::vscroll | OMLE::border);

   OEditor(const pOFrame Parent,
           const ULONG Style = OMLE::hscroll | OMLE::vscroll | OMLE::border);

   OEditor(const OFrame& Parent,
           const ULONG Style = OMLE::hscroll | OMLE::vscroll | OMLE::border);

   virtual ~OEditor();


// threads
   void loadFile(); 
   void saveFile();
   void saveFileAs();
};


#endif // OEDITOR_INCLUDED

// end of source
