// OCL - Class Library for OS/2 2.x and up
// (c) Benjamin Stein 1994
// All Rights Reserved
// OEntryField.hpp


#ifndef OEFIELD_INCLUDED
  #define OEFIELD_INCLUDED


#ifndef OSTRING_INCLUDED
  #include <OString.hpp>
#endif


#ifndef OFRAME_INCLUDED
  #include <OFrame.hpp>
#endif


typedef class OEntryField *pOEntryField;

class __CPP_EXPORT__ OEntryField : public OWindow
{
 protected:
    ULONG  limit;

 public:

    OEntryField(const ULONG id,
                const HWND Parent,
                const ULONG Style = ES_MARGIN | ES_AUTOSCROLL,
                const ULONG Limit = CCHMAXPATH);

    OEntryField(const OFrame& Parent,
                const ULONG Style = ES_MARGIN | ES_AUTOSCROLL,
                const ULONG Limit = CCHMAXPATH);

    OEntryField(const pOFrame Parent,
                const ULONG Style = ES_MARGIN | ES_AUTOSCROLL,
                const ULONG Limit = CCHMAXPATH);

    virtual ~OEntryField();

    BOOL  createEntryField(const ULONG x, const ULONG y,
                           const ULONG cx, const ULONG cy);

    BOOL  inherit(const HWND hwndDlg);

    BOOL  getText(OString& Buffer);

    BOOL  setText(PCSZ text);
    BOOL  setText(OString& Buffer);

    BOOL  cutText();
    BOOL  copyText();
    BOOL  pasteText();
    BOOL  clearText();
 
    BOOL  queryChanged();
    ULONG queryFirstChar();
    BOOL  queryRDOnly();
    BOOL  querySelection(USHORT& firstChar, USHORT& lastChar);

    BOOL  setFirstChar(const USHORT first);
    BOOL  setInsertMode(const BOOL insert = TRUE);
    BOOL  setRDOnly(const BOOL readOnly = TRUE);
    BOOL  setSelection(const USHORT firstChar, const USHORT lastChar);
    BOOL  setTextLimit(const USHORT limit);
};


#endif // OEFIELD_INCLUDED

// end of source
