// OCL - Class Library for OS/2 2.x and up
// (c) Benjamin Stein 1994
// All Rights Reserved
// OException.hpp



#ifndef OEXCEPTION_INCLUDED
  #define OEXCEPTION_INCLUDED


#ifndef OSTRING_INCLUDED
  #include <OString.hpp>
#endif


typedef class OException *pOException;

class __CPP_EXPORT__ OException
{
 protected:
   ULONG   state;

 public:
   OString description;
   OString Source;
   ULONG   Line;
   ULONG   rc;

 enum Severity {
   recoverable = 0,
   unrecoverable,
   fatal };

   OException(const PSZ err,                               // supplied error message
              const ULONG retcode,                         // an API return code
              const ULONG severity,
              const PSZ source = "",                       // module name
              const ULONG line = 0);                       // line number

   OException(const OString& err,                          // supplied error message
              const ULONG retcode,                         // an API return code
              const ULONG severity,
              const PSZ source = "",                       // module name
              const ULONG line = 0);                       // line number

   OException(const OException& ex);

   virtual ~OException();


   ULONG servity() {
    return(state); }

   virtual void viewError() = 0;
};



#endif // OEXCEPTION_INCLUDED

// end of source
