// OCL - Class Library for OS/2 2.x and up
// (c) Benjamin Stein 1994
// All Rights Reserved
// OFcl.hpp

// file collector

#ifndef FCL_INCLUDED
  #define FCL_INCLUDED


#ifndef OSTRING_INCLUDED
  #include <OString.hpp>
#endif

#ifndef LIST_INCLUDED
  #include <OList.hpp>
#endif

#ifndef LOSTRING_INCLUDED
  #include <lOString.hpp>
#endif


typedef class OFcl *pOFcl;

class __CPP_EXPORT__ OFcl
{
 protected:
     BOOL          stopASAP;

 private:
     PFILEFINDBUF3 pffb;
     PBYTE         tmp;
     ULONG         ulMaxFiles;
     ULONG         bufSize;
     BOOL          recurse;
     APIRET        rc;
     OString       filespec;
     OString       ext;
     BOOL          checkDate;
     BOOL          checkTime;

     void setupFilebuf();                   // allocate space for the buffer
     void finddirs(PSZ dir);                // find dirs in case of recursion
     void finddrives(PSZ spec);             // find all non removable drives
     void findfiles(ListItem<OString> *tmp);// find all files
     void addfiles();                       // set all found file into List this->files
     void adddirs(PSZ dir);                 // set all found dirs into List this->dirs
     void copy();                           // copy all batches into out
     BOOL hasDate(PFILEFINDBUF3 buf);
     BOOL hasTime(PFILEFINDBUF3 buf);

 public:
     OFcl();                                // constructor
     virtual ~OFcl();                       // destructor

     ULONG     AttrMask;                    // attribute mask (default FILE_NORMAL)
     DATETIME  *DateTime;
     lOString  dirs;                        // List of found dirs
     lOString  files;                       // List of found files
     ULONG     space;                       // amount of space used by all found files
     ULONG     found;                       // count of found files

     void fclinit();                        // delete all Lists
     void setCheck(BOOL date, BOOL time);
     void collect(PSZ spec,                 // collect files with this mask
                  BOOL rec,                 // recursive or not
                  BOOL local);              // all local drives?
     void fclstop();                        // stops the scanner immediatly
};




typedef class OScanFcl *pOScanFcl;

class __CPP_EXPORT__ OScanFcl : public OFcl
{
 private:
    PSZ       Buffer;
    PSZ       ToScan;

 public:
    lOString  good;
    ifstream  file;


    OScanFcl();
    virtual ~OScanFcl();

    BOOL init(PSZ FileName, PSZ toScan);
    void init(PSZ FileName);
    void release();
    BOOL check(PSZ string);
    void checkFiles(PSZ text);
};




#endif // FCL_INCLUDED

// end of source
