// OCL - Class Library for OS/2 2.x and up
// (c) Benjamin Stein 1994
// All Rights Reserved
// OFrame.hpp

#ifndef OFRAME_INCLUDED
  #define OFRAME_INCLUDED

#ifndef OWINDOW_INCLUDED
  #include <OWindow.hpp>
#endif



typedef class OFrame *pOFrame;


class __CPP_EXPORT__ OFrame : public OWindow
{
 public:
   HWND      frame;
   HWND      client;

// ctor/dtor

   OFrame(const ULONG id,
          const ULONG Style = FCF_STANDARD,
          const ULONG winbits = CS_SAVEBITS | CS_SIZEREDRAW);

   virtual ~OFrame();

   BOOL createFrame(PCSZ className);

   virtual void setSizePosFrame(const HWND behind,
                                SWP dimensions,
                                const ULONG flag);
   virtual void showFrame();
   virtual void hideFrame();
   virtual void centerFrame();
   void postQuit();
   void destroyFrame();
   void setWindowText(PCSZ text);


// CommandHandler
// this default handler handles font and color configuration by drag and drop

   virtual BOOL OCommand(ULONG msg, MPARAM mp1, MPARAM mp2);
};


#endif // OFRAME_INCLUDED

// end of source
