// OCL - Class Library for OS/2 2.x and up
// (c) Benjamin Stein 1994
// All Rights Reserved
// OHelp.hpp


#ifndef OHELP_INCLUDED
  #define OHELP_INCLUDED



#ifndef OMSGS_INCLUDED
  #include <OMsgs.hpp>
#endif



typedef class OHelp *pOHelp;


class __CPP_EXPORT__ OHelp : public OMsgs
{
 private: 
    ULONG table;
    ULONG errid;
    HWND  helpInstance;
    HWND  assoc;

 public:
    BOOL  isHlpAvail;

 enum {
      help    = 0,
      general = HM_GENERAL_HELP,
      keys    = HM_KEYS_HELP,
      index   = HM_HELP_INDEX
    };

    OHelp(const ULONG mainTable, 
          const ULONG errorID);  // errorID is a stringtable ID containing the error message
                                 // beeing displayed if no help is available
    virtual ~OHelp();

    BOOL initializeHelp(PCSZ helpLibrary, PCSZ title, const HWND associated);
 
    void terminateHelp();

    BOOL helpRequest(const ULONG id);
};

#endif // OHELP_INCLUDED
 

// end of source
