// OCL - Class Library for OS/2 2.x and up
// (c) Benjamin Stein 1994
// All Rights Reserved
// OList.hpp


#ifndef OLIST_INCLUDED
  #define OLIST_INCLUDED


#ifndef OLISTBASE_INCLUDED
  #include <OListBase.hpp>
#endif


template <class T>
class List :  public OListBase
{
 public:
    List();
    virtual ~List();


// overloaded pure virtuals

    void freeItem(PVOID elem);

    virtual void output(PVOID elem);

// tools

    T* getFirst();
    T* getLast();
    T* get();
    T* getNext();
    T* getNext(T *elem);
    T* getPrev();
    T* getPrev(T *elem);
    T* getItem(ULONG itemNum);

    ListItem<T>* getNextListItem(T *elem);
    ListItem<T>* getPrevListItem(T *elem);

// virtuals

    virtual void add(T& elem);
    virtual void add(T* elem);
};


#endif // OLIST_INCLUDED

// end of source
