// OCL - Class Library for OS/2 2.x and up
// (c) Benjamin Stein 1994
// All Rights Reserved
// OListBase.hpp


#ifndef OLISTBASE_INCLUDED
  #define OLISTBASE_INCLUDED


#if (defined ( __IBMCPP__ ) && !defined ( OCL_HPP_INCLUDED ))  // in case of template generation
  #define INCL_DOS
  #define INCL_WIN
  #define INCL_PM
  #include <ocl.hpp>
#endif


template <class T>
struct ListItem
{
 ListItem<T>  *next;  // nchstes ListItem
 ListItem<T>  *prev;  // vorhergehendes ListItem
 T            *item;  // Daten
};


typedef ListItem<VOID> PVITEM;
typedef PVITEM *PPVITEM;

class __CPP_EXPORT__ OListBase
{
 public:
    ULONG       items;    // number of elements in list
    PPVITEM     actual;   // last accessed element
    PPVITEM     first;    // first element
    PPVITEM     last;     // last element

    OListBase();          
    virtual ~OListBase(); 

    BOOL    isEmpty();    // Ist die Liste leer?
    void    rewind();     // setzt actual auf first
    void    init();       // Liste leeren 

    virtual void reset(); // Liste leeren (und Lschen aller Items!!!)

    virtual void addFirst(PVOID elem);
    virtual void addLast(PVOID elem);

    virtual void addAfter(PVOID previous, PVOID elem);
    virtual void addAfter(PPVITEM previous, PVOID elem);

    virtual PVOID   _getFirst();
    virtual PVOID   _getLast();

    virtual PVOID   _getNext();          // gibt den Nachfolger von actual zurck
    virtual PVOID   _getNext(PVOID elem);
    virtual PPVITEM _getNextListItem(PVOID elem);

    virtual PVOID   _getPrev();          // gibt den Vorgnger von actual zurck
    virtual PVOID   _getPrev(PVOID elem);
    virtual PPVITEM _getPrevListItem(PVOID elem);

    virtual PVOID   _getItem(ULONG itemNum);

    virtual void    remove(PVOID elem); // entfernt ein bestimmtes Element
    virtual void    del(PVOID elem);    // entfernt ein bestimmtes Element und gibt den Speicher frei

    virtual void    print();

// pure virtuals

    virtual void freeItem(PVOID elem) = 0;
    virtual void output(PVOID elem) = 0;
};


#endif // OLISTBASE_INCLUDED



// end of source
