// OCL - Class Library for OS/2 2.x and up
// (c) Benjamin Stein 1994
// All Rights Reserved
// OListBox.hpp


#ifndef OLISTBOX_INCLUDED
  #define OLISTBOX_INCLUDED


#ifndef OFRAME_INCLUDED
  #include <OFrame.hpp>
#endif

#ifndef OSTRING_INCLUDED
  #include <OString.hpp>
#endif


// Note - the following styles are available

// LS_MULTIPLESEL             0x00000001L
// LS_OWNERDRAW               0x00000002L
// LS_NOADJUSTPOS             0x00000004L
// LS_HORZSCROLL              0x00000008L
// LS_EXTENDEDSEL             0x00000010L


typedef class OListBox *pOListBox;


class __CPP_EXPORT__ OListBox : public OWindow
{
 public:

    OListBox(const ULONG id,
             const HWND Parent,
             const ULONG Style = LS_NOADJUSTPOS | LS_EXTENDEDSEL);

    OListBox(const OFrame& Parent,
             const ULONG Style = LS_NOADJUSTPOS | LS_EXTENDEDSEL);

    OListBox(const pOFrame Parent,
             const ULONG Style = LS_NOADJUSTPOS | LS_EXTENDEDSEL);

    virtual ~OListBox();

    BOOL  createListBox(const ULONG x, const ULONG y,
                        const ULONG cx, const ULONG cy);


    BOOL  deleteAll();
    ULONG deleteItem(const ULONG itemIndex);

    ULONG insertItem(const PSZ text, const ULONG itemIndex = LIT_END);
    ULONG insertItem(const OString& text, const ULONG itemIndex = LIT_END);

    ULONG queryItemCount();
    ULONG queryItemHandle(const ULONG itemIndex);
    ULONG queryItemText(OString& Buffer, const ULONG itemIndex);
    ULONG queryItemTextLength(const ULONG itemIndex);
    ULONG querySelection(const ULONG itemStart);
    ULONG queryTopItem();

    ULONG searchString(const PSZ text,
                       const ULONG itemStart = LIT_FIRST, 
                       const ULONG command = LSS_CASESENSITIVE);
    ULONG searchString(const OString& text,
                       const ULONG itemStart = LIT_FIRST,
                       const ULONG command = LSS_CASESENSITIVE);
 
    BOOL  selectItem(const ULONG itemIndex, const BOOL state = TRUE);

    BOOL  setItemHandle(const ULONG itemIndex, const ULONG handle);
    BOOL  setItemHeight(const ULONG newHeight);
    BOOL  setItemText(const ULONG itemIndex, const PSZ text);
    BOOL  setItemText(const ULONG itemIndex, const OString& text);
    BOOL  setToTop(const ULONG itemIndex);
};


#endif // OLISTBOX_INCLUDED

// end of source
