// OCL - Class Library for OS/2 2.x and up
// (c) Benjamin Stein 1994
// All Rights Reserved
// OMLE.hpp

#ifndef OMLE_INCLUDED
  #define OMLE_INCLUDED


#ifndef OFRAME_INCLUDED
  #include <oframe.hpp>
#endif

#ifndef OSTRING_INCLUDED
  #include <OString.hpp>
#endif

#ifndef OTHREAD_INCLUDED
  #include <OThread.hpp>
#endif


typedef class OMLE *pOMLE;

typedef OThread<OMLE> OMLEThread;


class __CPP_EXPORT__ OMLE : public OWindow
{
 protected:
   PVOID      imex;
   ULONG      imexLen;
   IPT        imexOffset;

 public:
   OMLEThread insertLargeThr;
   OString    openedFile;

// enums

   enum {
     text   = MLFIE_CFTEXT,
     binary = MLFIE_NOTRANS,
     winmle = MLFIE_WINFMT };

   enum {
     border  = MLS_BORDER,
     rdonly  = MLS_READONLY,
     wrap    = MLS_WORDWRAP,
     hscroll = MLS_HSCROLL,
     vscroll = MLS_VSCROLL,
     notab   = MLS_IGNORETAB,
     noundo  = MLS_DISABLEUNDO };


// ctors/dtor

   OMLE(const ULONG id,
        const HWND Parent,
        const ULONG Style = OMLE::hscroll | OMLE::vscroll | OMLE::border);

   OMLE(const OFrame& Parent,
        const ULONG Style = OMLE::hscroll | OMLE::vscroll | OMLE::border);

   OMLE(const pOFrame Parent,
        const ULONG Style = OMLE::hscroll | OMLE::vscroll | OMLE::border);

   virtual ~OMLE();


   BOOL  createMLE(const ULONG x = 0, const ULONG y = 0,
                   const ULONG cx = 0, const ULONG cy = 0);

// text related

   virtual ULONG  getText(PVOID out, ULONG len);
   virtual ULONG  getText(OString& Buffer);

   virtual ULONG  setText(PVOID in, ULONG len);
   virtual ULONG  setText(PSZ text);
   virtual ULONG  setText(OString& text);

   virtual BOOL   insertText(PSZ text);
   virtual BOOL   insertText(OString& text);

   BOOL  copy();
   BOOL  cut();
   BOOL  paste();
   BOOL  copy2Clip();
   BOOL  cut2Clip();
   BOOL  pasteFromClip();
   BOOL  clear();
   BOOL  undo();

   BOOL  deleteText(ULONG beginPoint, ULONG count);
   BOOL  deleteAll();

// services

   ULONG length();
   ULONG lines();

   BOOL  changed();
   ULONG setFormat(const ULONG format);
   void  disableRefresh();
   void  enableRefresh();

   BOOL  insertFile(PCSZ fileName);

// threads
   void insertLarge();
};


#endif // OMLE_INCLUDED

// end of source
