// OCL - Class Library for OS/2 2.x and up
// (c) Benjamin Stein 1994
// All Rights Reserved
// OMsgs.hpp
// Message Boxes


#ifndef OMSGS_INCLUDED
  #define OMSGS_INCLUDED

#ifndef OAPP_INCLUDED
  #include <OApp.hpp>
#endif

typedef class OMsgs *pOMsgs;

class __CPP_EXPORT__ OMsgs
{
 protected:
   HMODULE handle;
   CHAR    Msg[2*CCHMAXPATH];
   CHAR    Title[60];

 public:

   OMsgs(const HMODULE moduleHandle = NULLHANDLE);

   virtual ~OMsgs();
 
   void setResource(const HMODULE moduleHandle = NULLHANDLE);

   void info(const ULONG msgID);
   void info(const ULONG titleID, const ULONG msgID);
   void info(PCSZ msg);
   void info(PCSZ title, PCSZ msg);

   void error(const ULONG msgID);
   void error(const ULONG titleID, const ULONG msgID);
   void error(PCSZ msg);
   void error(PCSZ title, PCSZ msg);

   BOOL ask(const ULONG titleID, const ULONG msgID);
   BOOL ask(PCSZ title, PCSZ msg);

   BOOL loadString(const ULONG resID, const ULONG Size, PSZ str);

   void beeper();
};

#endif  // OMSGS_INCLUDED



// end of source
