// OCL - Class Library for OS/2 2.x and up
// (c) Benjamin Stein 1994
// All Rights Reserved
// OMuxSem.hpp


#ifndef OMUXSEM_INCLUDED
  #define OMUXSEM_INCLUDED



#ifndef OSTRING_INCLUDED
  #include <OString.hpp>
#endif

#ifndef OVIOEXCEPTION_INCLUDED
  #include <OVioException.hpp>
#endif


typedef class OMuxSem *pOMuxSem;


// in case of any return value !TRUE check muxState for error number


class __CPP_EXPORT__ OMuxSem
{
 private:
   OString muxName;
   HMTX    hmtx;

 public:
   ULONG   muxState;

 enum OMuxSemState
   {
    immediate = SEM_IMMEDIATE_RETURN,
    indefinite = SEM_INDEFINITE_WAIT
   };

 enum OMuxSemAction
   {
    create = 0,
    open
   };

   OMuxSem(HMTX handle);                 // construct from existing handle
                                         // throws OVioException if the handle is invalid

   OMuxSem(PCSZ name,                    // throws OVioException if create/open fails
           ULONG action = OMuxSem::create,
           BOOL shared = TRUE);          // ignored if action == OMuxSem::open

   virtual ~OMuxSem();
 

   BOOL openMuxSem(HMTX handle);
   BOOL openMuxSem(PCSZ name);

   BOOL closeMuxSem();

   BOOL requestMuxSem(ULONG timeOut = OMuxSem::indefinite);
   BOOL releaseMuxSem();

   BOOL queryMuxSem(PPID pid,           // returns current owners process id
                    PTID tid);          // returns current owners thread id

   void setMuxSemHandle(HMTX handle);
   HMTX getMuxSemHandle();
};




#endif // OMUXSEM_INCLUDED

// end of source
