// OCL - Class Library for OS/2 2.x and up
// (c) Benjamin Stein 1994
// All Rights Reserved
// OPMException.hpp


#ifndef OPMEXCEPTION_INCLUDED
  #define OPMEXCEPTION_INCLUDED


#ifndef OEXCEPTION_INCLUDED
  #include <OException.hpp>
#endif

#ifndef OAPP_INCLUDED
 #include <OApp.hpp>
#endif

#ifndef OMSGS_INCLUDED
 #include <OMsgs.hpp>
#endif


typedef class OPMException *pOPMException;


class __CPP_EXPORT__ OPMException : public OException, public OMsgs
{
 public:
   OString message;
   ULONG   errRes;

   OPMException(const PSZ err,                     // supplied error message
                const ULONG retcode,               // an API return code
                const ULONG severity = OException::unrecoverable,
                const PSZ source = "",             // module name
                const ULONG line = 0);             // source code line

   OPMException(const OString& err,
                const ULONG retcode,
                const ULONG severity = OException::unrecoverable,
                const PSZ source = "",             // module name
                const ULONG line = 0);             // source code line

   OPMException(const ULONG errResource,           // resource id in stringtable
                const ULONG retcode,               // an API return code
                const ULONG severity = OException::unrecoverable,
                const HMODULE mod = NULLHANDLE,    // module to load errResource from
                const PSZ source = "",             // module name
                const ULONG line = 0);             // source code line

   OPMException(const OPMException& ex);

   virtual ~OPMException();

   virtual void viewError();       // shows an error box with the formatted error message
};


#define OThrowPM(a, b, c) (throw OPMException(a, b, c, __FILE__, __LINE__));


#endif // OPMEXCEPTION_INCLUDED


// end of source
