// OCL - Class Library for OS/2 2.x and up
// (c) Benjamin Stein 1994
// All Rights Reserved
// OPROFILE.HPP


#ifndef OPROFILE_INCLUDED
  #define OPROFILE_INCLUDED


#ifndef OSTRING_INCLUDED
  #include <ostring.hpp>
#endif

// object creator

typedef class OProfile *pOProfile;

class __CPP_EXPORT__ OProfile
{
 public:
      HINI     hini;
      lOString list;
      OString  val;

      OProfile();
      OProfile(PSZ iniName);
      OProfile(const HINI iniHandle);

      virtual ~OProfile();

      BOOL open(PSZ iniName);
      void close();

      BOOL setupList(UCHAR *DatTemp);

      BOOL write(PSZ App, PSZ Key, PVOID Value, ULONG len);

      BOOL deleteApp(PSZ App);
      BOOL deleteKey(PSZ App, PSZ Key);

      BOOL getApps();
      BOOL getKeys(PSZ App);
      BOOL getStr(PSZ App, PSZ Key);
      BOOL getData(PSZ App, PSZ Key, PVOID Buffer, PULONG Size);

      BOOL insert(const HWND hwnd, const ULONG id);
};


#endif

// end of source
