// OCL - Class Library for OS/2 2.x and up
// (c) Benjamin Stein 1994
// All Rights Reserved
// OSortedList.c


#ifndef SORTEDLIST_INLINED
  #define SORTEDLIST_INLINED


#ifdef __IBMCPP__
  #define INCL_WIN
  #define INCL_PM
  #define INCL_DOS
  #define OINCL_BASE
  #include <ocl.hpp>
#endif


template <class T>
SortedList<T>::SortedList() {}

template <class T>
SortedList<T>::~SortedList() {}


template <class T>
void SortedList<T>::freeItem(PVOID elem)
{ 
 delete (T*) elem; 
}

template <class T>
void SortedList<T>::output(PVOID elem)
{}


template <class T>
BOOL SortedList<T>::_isLess(PVOID first, PVOID second)
{ 
 return(isLess((T*)first, (T*)second)); 
}


template <class T>
T* SortedList<T>::getFirst()
{ 
 return((T*) OListBase::_getFirst()); 
}


template <class T>
T* SortedList<T>::getLast()
{ 
 return((T*) OListBase::_getLast()); 
}


template <class T>
T* SortedList<T>::get()
{ 
 return((T*) OListBase::_getNext()); 
}


template <class T>
T* SortedList<T>::getNext()
{ 
 return((T*) OListBase::_getNext()); 
}


template <class T>
T* SortedList<T>::getNext(T *elem)
{ 
 return((T*) OListBase::_getNext(elem)); 
}


template <class T>
T* SortedList<T>::getPrev()
{ 
 return((T*) OListBase::_getPrev()); 
}


template <class T>
T* SortedList<T>::getPrev(T *elem)
{ 
 return((T*) OListBase::_getNext(elem)); 
}


template <class T>
T* SortedList<T>::getItem(ULONG itemNum)
{ 
 return((T*) OListBase::_getItem(itemNum)); 
}


template <class T>
ListItem<T>* SortedList<T>::getNextListItem(T *elem)
{ 
 return((ListItem<T>*) OListBase::_getNextListItem(elem)); 
}


template <class T>
ListItem<T>* SortedList<T>::getPrevListItem(T *elem)
{ 
 return((ListItem<T>*) OListBase::_getPrevListItem(elem)); 
}



template <class T>
void SortedList<T>::add(T& elem)
{ 
 OSortedListBase::addSorted(&elem); 
}


template <class T>
void SortedList<T>::add(T* elem)
{ 
 OSortedListBase::addSorted(elem); 
}



#endif // SORTEDLIST_INLINED

// end of source
