// OCL - Class Library for OS/2 2.x and up
// (c) Benjamin Stein 1994
// All Rights Reserved
// OSortedListBase.hpp


#ifndef OSORTEDLISTBASE_INCLUDED
  #define OSORTEDLISTBASE_INCLUDED


#ifndef OLISTBASE_INCLUDED
  #include <OListBase.hpp>
#endif

#ifndef OMUXSEM_INCLUDED
  #include <OMuxSem.hpp>
#endif


class __CPP_EXPORT__ OSortedListBase : protected OMuxSem, public OListBase
{
 protected:
    ULONG    slistCursor;
    BOOL     sortAscending;  // FALSE means descending, default is ascending

    void addSortAscending(PVOID elem);
    void addSortDescending(PVOID elem);
    void addSorted(PVOID elem);

 public:

    OSortedListBase();
    virtual ~OSortedListBase();

    void setAscending(BOOL ascending);   // FALSE means descending

// pure virtual

    virtual void freeItem(PVOID elem) = 0;
    virtual BOOL _isLess(PVOID first, PVOID second) = 0;
};


#endif // SORTEDLIST_INCLUDED

// end of source
