// OCL - Class Library for OS/2 2.x and up
// (c) 1994 M. Stbner
// All Rights Reserved
// OSPINBTN.hpp


#ifndef OSPINBTN_INCLUDED
  #define OSPINBTN_INCLUDED


#ifndef OFRAME_INCLUDED
  #include <OFrame.hpp>
#endif


/* Mgliche Styles fr einen Spinbutton sind:

SPBS_MASTER         -   Spinbutton mit Pfeilen
SPBS_SERVANT        -   Spinbutton ohne Pfeile

SPBS_ALLCHARACTERS  -   alle Zeichen
SPBS_NUMERICONLY    -   nur Ziffern
SPBS_READONLY       -   nur lesbar

SPBS_JUSTLEFT       -   Inhalt linksjustiert
SPBS_JUSTRIGHT      -   Inhalt rechtsjustiert
SPBS_JUSTCENTER     -   Inhalt zentriert
SPBS_NOBORDER       -   ohne Rand

SPBS_FASTSPIN       -   erhhtes Spintempo
SPBS_PADWITHZERO    -   auffllen mit Nullen
*/


typedef class OSpinBtn *pOSpinBtn;

class __CPP_EXPORT__ OSpinBtn : public OWindow
{
 public:

// ctors
    OSpinBtn(const ULONG ID,
             const HWND  Parent,  // becomes parent and owner of the slider
             const ULONG Style);

    OSpinBtn(const OFrame& Parent, 
             const ULONG Style);

    OSpinBtn(const pOFrame Parent, 
             const ULONG Style);

// dtor
    virtual ~OSpinBtn();

    BOOL createSpinBtn(const SHORT x, const SHORT y,
                       const SHORT cx, const SHORT cy);

    BOOL setArray(PSZ array, ULONG num);

    // index ist der Index im Array, NICHT der Wert selber
    BOOL setCurrent(LONG index);
    BOOL setLimits(LONG upper, LONG lower);
    BOOL setMaster(HWND master);
    BOOL setTextLimit(USHORT length);
    BOOL OverrideLimits(LONG upper, LONG lower);
    BOOL incSpin(ULONG delta = 1);
    BOOL decSpin(ULONG delta = 1);

    BOOL getLimits(LONG *upper, LONG *lower);
    BOOL getCurrent(PVOID addr, USHORT size, USHORT control = SPBQ_UPDATEIFVALID);

    BOOL jumptoEnd();
    BOOL jumptoStart();
};


#endif // OSPINBTN_INCLUDED
