// OCL - Class Library for OS/2 2.x and up
// (c) Benjamin Stein 1994
// All Rights Reserved
// OStatusLine.hpp

// frame window status line

#ifndef STATUSLINE_INCLUDED
  #define STATUSLINE_INCLUDED


#ifndef OFRAME_INCLUDED
  #include <OFrame.hpp>
#endif

typedef class OStatusLine *pOStatusLine;

class __CPP_EXPORT__ OStatusLine : public OFrame
{
 protected:
    void    initStatlineDefaults();

 private:
    OString statlineText;
    BOOL    readOnly;
    ULONG   orientation;

 public:

    OStatusLine(const ULONG id,
                const HWND Parent);
    OStatusLine(const OFrame& Parent);
    OStatusLine(const pOFrame Parent);
 
    virtual ~OStatusLine();

    BOOL  createStatusLine();
    void  refreshText();
    void  setText(PCSZ text);
    ULONG getHeight();
    void  setOrientation(const ULONG Orientation);
    void  setRDOnly(BOOL readonly);

    BOOL  OCommand(ULONG msg, MPARAM mp1, MPARAM m2);
};



#endif // STATUSLINE_INCLUDED


// end of source
