// OCL - Class Library for OS/2 2.x and up
// (c) Benjamin Stein 1994
// All Rights Reserved
// OString.hpp


#ifndef OSTRING_INCLUDED
  #define OSTRING_INCLUDED


// single text-line with unknown length
typedef class OString *pOString;

class __CPP_EXPORT__ OString
{
 public:
    PSZ text;

    PSZ getText();

    OString();
    OString(const PSZ iText);
    OString(const OString& String);
    OString(const pOString String);
    OString(int iLength);

    virtual ~OString();

    int compare(OString&  s1, OString& s2);

    OString& operator << (PSZ string);
    OString& operator << (OString& string);
    OString& operator << (pOString string);

    void operator >> (PSZ string);

    OString& operator + (PSZ string);
    OString& operator + (OString& string);
    OString& operator + (pOString string);

    OString& operator - (int Letter);

    friend ostream& operator<< (ostream& out, OString& s);
    friend istream& operator>> (istream& in, OString& s);

    BOOL operator ! ()const;

    int  operator == (const OString& anOther)const;
    int  operator == (PSZ anOther)const;
    int  operator != (const OString& anOther)const;
    int  operator < (const OString& anOther)const;
    int  operator > (const OString& anOther)const;
    int  operator <= (const OString& anOther)const;
    int  operator >= (const OString& anOther)const;

    OString& operator = (const OString& iString);
} ;



#if ((defined OINCL_LOSTRING) || (defined OINCL_BASE))
  #include <lOString.hpp>
#endif


#ifdef OINCL_SLOSTRING
  #include <slOString.hpp>
#endif


#endif // OSTRING_INCLUDED


// end of source
