// OCL - Class Library for OS/2 2.x and up
// (c) Benjamin Stein 1994
// All Rights Reserved
// OSysInfo.hpp


#ifndef OSYSINFO_INLUDED
  #define OSYSINFO_INLUDED

// a System Information Class


#ifndef LIST_INCLUDED
  #include <OList.hpp>
#endif

#ifndef OSTRING_INCLUDED
  #include <OString.hpp>
#endif

#ifndef LOSTRING_INCLUDED
  #include <lOString.hpp>
#endif

typedef class OSysInfoVIO *pOSysInfoVIO;

class __CPP_EXPORT__ OSysInfoVIO
{
 public:
    lOString   SysInfoList;
    OString    SysInfoVar;

    OSysInfoVIO();
    virtual ~OSysInfoVIO();

    BOOL getDrives();                 // get all drives (and drive labels)
    BOOL getEnv(PCSZ env);            // get an environment variable
    BOOL getBootDrive();              // get the system boot drive
    BOOL getCfgEnv(PSZ env);          // get a system setting from CONFIG.SYS
    BOOL getOSVer();                  // get the OS/2 version number as string in SysInfoVar
    BOOL getOSVer(double& version);   // get OS/2 version number as double in passed reference

    BOOL findPathFile(PCSZ file);     // find a file in path
    BOOL checkRemovable(PCSZ Drive);  // check if drive is a nonremovable local drive
    BOOL clearRDOnly(PCSZ FileName);  // reset readonly flag of a file
};


typedef class OSysInfo *pOSysInfo;

class __CPP_EXPORT__ OSysInfo : public OSysInfoVIO
{
 public:
    OSysInfo();
    virtual ~OSysInfo();

    BOOL getDesktop();               // get the Desktop directory
};


#endif  // OSYSINFO_INCLUDED



// end of source
