// OCL - Class Library for OS/2 2.x and up
// (c) Benjamin Stein 1994
// All Rights Reserved
// OThread.c



#ifndef OTHREAD_INLINED
  #define OTHREAD_INLINED


#ifdef __IBMCPP__

template <class T>
OThread<T>::OThread(OptlinkFnPtr aFunction,
                    ULONG stackSize,
                    BOOL forPM,
                    PVOID pvData)
     : OThreadBase(stackSize, forPM),
       member(NULL),
       object((T*)NULL),
       threadFunc((PFNTHREAD)aFunction),
       pArgs(pvData)
{}
#endif



template <class T>
OThread<T>::OThread(T* obj,                  // pointer to object
                    void(T::*mem)(),         // pointer to member-fn to detach
                    ULONG stackSize,         // stacksize for thread
                    BOOL  forPM)             // initialize PM?
     : OThreadBase(stackSize, forPM),
       member(mem),
       object(obj),
       threadFunc(NULL),
       pArgs(NULL)
{}


template <class T>
OThread<T>::OThread(T& obj,                   // reference to object
                    void(T::*mem)(),          // pointer to member-fn to detach
                    ULONG stackSize,          // stacksize for thread
                    BOOL  forPM)              // initialize PM?
     : OThreadBase(stackSize, forPM),
       member(mem),
       object(&obj),
       threadFunc(NULL),
       pArgs(NULL)
{}

template <class T>
OThread<T>::OThread(PFNTHREAD aFunction,
                    ULONG stackSize,
                    BOOL forPM,
                    PVOID pvData)
     : OThreadBase(stackSize, forPM),
       member(NULL),
       object((T*)NULL),
       threadFunc(aFunction),
       pArgs(pvData)
{}


template <class T>
OThread<T>::~OThread()
{}


template <class T>
void OThread<T>::async() 
{
 if (threadFunc != NULL)
   threadFunc((ULONG)pArgs);
 else if (object)
   (object->*member)(); 
}


#endif  // OTHREAD_INLINED


// end of source
