// OCL - Class Library for OS/2 2.x and up
// (c) Benjamin Stein 1994
// All Rights Reserved
// OValueSet.hpp


#ifndef OVALUE_INCLUDED
  #define OVALUE_INCLUDED


#ifndef OFRAME_INCLUDED
  #include <OFrame.hpp>
#endif


#ifndef OSTRING_INCLUDED
  #include <OString.hpp>
#endif

// possible styles for value sets
// VS_ITEMBORDER
// VS_BORDER
// VS_TEXT
// VS_ICON
// VS_BITMAP
// VS_RGB
// VS_COLORINDEX
// VS_RIGHTTOLEFT
// VS_SCALEBITMAPS
// VS_OWNERDRAW


typedef struct vsItem *pvsItem;

struct vsItem
{
 USHORT   row;
 USHORT   col;
 USHORT   colorIndex;
 OString  text;
 HPOINTER icon;
 HBITMAP  bitmap;
 RGB      rgb;
};


typedef class OValueSet *pOValueSet;


class __CPP_EXPORT__ OValueSet : public OWindow
{
 private:
   VSCDATA  ctlData;
   ULONG    rows;
   ULONG    columns;
   ULONG    margin;

 public:
   vsItem   selected;

// ctors
   OValueSet(const ULONG ID,
             const HWND  Parent,      // becomes parent and owner of the set
             const ULONG Rows = 2,
             const ULONG Columns = 2,
             const ULONG Margin = 0,
             const ULONG Style = VS_ITEMBORDER | VS_BORDER | VS_ICON);

   OValueSet(const OFrame& Parent,   // becomes parent and owner of the set
             const ULONG Rows = 2,
             const ULONG Columns = 2,
             const ULONG Margin = 0,
             const ULONG Style = VS_ITEMBORDER | VS_BORDER | VS_ICON);

   OValueSet(const pOFrame Parent,   // becomes parent and owner of the set
             const ULONG Rows = 2,
             const ULONG Columns = 2,
             const ULONG Margin = 0,
             const ULONG Style = VS_ITEMBORDER | VS_BORDER | VS_ICON | WS_TABSTOP);

// dtor
    virtual ~OValueSet();

    BOOL createValueSet(const SHORT x, const SHORT y,
                        const SHORT cx, const SHORT cy);

// tools section

    // data will be placed in OValueSet::selected
    BOOL  querySelected();
    BOOL  queryItem(ULONG row = 1, ULONG col = 1);
    ULONG queryItemAttr(ULONG row = 1, ULONG col = 1);
    ULONG queryMetrics(ULONG fMetric = VMA_ITEMSIZE);

    BOOL  selectItem(ULONG row = 1, ULONG col = 1);
    BOOL  setItem(ULONG row, ULONG col, ULONG itemInfo);
    BOOL  setItemAttr(ULONG row = 1, ULONG col = 1, ULONG attribute = VS_ICON, BOOL set = TRUE);
    BOOL  setMetrics(ULONG fMetric, ULONG itemInfo);
};







#endif // OVALUE_INCLUDED


// end of source
