// OCL - Class Library for OS/2 2.x and up
// (c) Benjamin Stein 1994
// All Rights Reserved
// OVioException.hpp



#ifndef OVIOEXCEPTION_INCLUDED
  #define OVIOEXCEPTION_INCLUDED


#ifndef OSTRING_INCLUDED
  #include <OString.hpp>
#endif

#ifndef OEXCEPTION_INCLUDED
  #include <OException.hpp>
#endif

typedef class OVioException *pOVioException;

class __CPP_EXPORT__ OVioException : public OException
{
 public:

   OVioException(const PSZ err,           // supplied error message
                 const ULONG retcode,     // an API return code
                 const ULONG severity = OException::unrecoverable,
                 const PSZ source = "",   // module name
                 const ULONG line = 0);   // line number

   OVioException(const OString& err,
                 const ULONG retcode,
                 const ULONG severity = OException::unrecoverable,
                 const PSZ source = "",
                 const ULONG line = 0);

   OVioException(const OVioException& ex);

   virtual ~OVioException();

   virtual void viewError();            // prints the formatted error message to cerr
};

#define OThrowVio(a, b, c) (throw OException(a, b, c, __FILE__, __LINE__))


#endif // OVIOEXCEPTION_INCLUDED

// end of source
