// OCL - Class Library for OS/2 2.x and up
// (c) Benjamin Stein 1994
// All Rights Reserved
// OWindow.hpp

#ifndef OWINDOW_INCLUDED
#define OWINDOW_INCLUDED



#ifndef OAPP_INCLUDED
  #include <OApp.hpp>
#endif



typedef struct _PresParms
{
 COLOR   Fore;
 COLOR   Back;
 CHAR    Font[80];
} PresParms, *pPresParms;


typedef class OWindow *pOWindow;

class __CPP_EXPORT__ OWindow : public OCommandHandler
{
 public:
   HWND      parent;
   HWND      owner;
   BOOL      termFlag;
   ULONG     res;
   ULONG     style;
   ULONG     bits;
   OString   winText;
   HPS       hps;
   RECTL     rcl;
   SWP       sizepos;
   PresParms pparms;

   OWindow(const ULONG id, 
           const ULONG winstyle, 
           const ULONG winbits);

   virtual ~OWindow();

   virtual BOOL inherit(const HWND hwndDlg); // call this in WM_INITDLG when a dialog
                                             // control was "deadly" constructed
                                             // or when frame extensions were constructed
                                             // before OFrame::createFrame(...)
   void show();
   void hide();
   void enable();
   void disable();
   void activate();
   void destroy();
   void setFocus();
   void setParent(const HWND handle);
   void setOwner(const HWND handle);

// presentation setup

   void setForeColor(COLOR color);
   void setBackColor(COLOR color);
   void setFont(PSZ fontnamesize);
   void setPresentation(pPresParms presentation);

   COLOR getForeColor();
   COLOR getBackColor();
   PSZ   getFont();
   void  getPresentation(pPresParms presentation);

   BOOL  initReplace(const ULONG id, SWP& swp);  // the OWindow should replace window id
};


#endif // OWINDOW_INCLUDED

// end of source
