// OCL - Class Library for OS/2 2.x and up
// (c) Benjamin Stein 1994
// All Rights Reserved
// OXcptBase.hpp


#ifndef OXCPTBASE_INCLUDED
  #define OXCPTBASE_INCLUDED

#ifndef OSTRING_INCLUDED
  #include <OString.hpp>
#endif


typedef class OXcptBase *pOXcptBase;

typedef EXCEPTIONREGISTRATIONRECORD OXCPTRECORD;


class __CPP_EXPORT__ OXcptBase
{
 protected:
  OXCPTRECORD  *record;
  BOOL         killMsg;

 public:
  ULONG       times;

  OXcptBase(BOOL killMessages = FALSE); // provide detailed information about kill cases

  virtual ~OXcptBase();

  virtual BOOL trapTrace() = 0;
  virtual BOOL killTrace() = 0;
  virtual void exceptionMessage(OString& msg) = 0;
  virtual BOOL handler(PEXCEPTIONREPORTRECORD report,
                       PCONTEXTRECORD context,
                       PVOID pargs);

  BOOL setHandler(OXCPTRECORD& regRecord);
  BOOL unsetHandler();


// for internal use, do not change

  static ULONG OXCPT_CATCH(EXCEPTIONREPORTRECORD *report,
                           OXCPTRECORD *record,
                           CONTEXTRECORD *context,
                           PVOID pargs);

  static OXcptBase *currentHandler;
};


#endif // OXCPTBASE_INCLUDED

// end of source
