// OCL - Class Library for OS/2 2.x and up
// (c) Benjamin Stein 1994
// All Rights Reserved
// OApp.cpp


#define INCL_DOS
#define OINCL_BASE

#include <ocl.hpp>
#include <OCommand.hpp>
#include <OApp.hpp>


// OApp


pOApp OApp::currentOApp = (pOApp)NULL;


OApp::OApp(ULONG queueSize) 
  : OPMinit(queueSize)
{
 if (!OApp::currentOApp)
   OApp::currentOApp = this;
}


OApp::OApp(const ULONG num, CHAR *Parms[], ULONG queueSize)
  : OAppBase(num, Parms),
    OPMinit(queueSize)
{
 if (!OApp::currentOApp)
   OApp::currentOApp = this;
}


OApp::~OApp() 
{
 if (OApp::currentOApp == this)
   OApp::currentOApp = NULL;
}



BOOL OApp::OCMDTrace(const HWND hwnd,
                     const ULONG msg,
                     const MPARAM mp1,
                     const MPARAM mp2)
{
 pOCommandHandler pcm = (pOCommandHandler) WinQueryWindowULong(hwnd, QWL_USER);

 if (pcm) {
   pcm->hwnd = hwnd;
   return(pcm->OCommand(msg, mp1, mp2)); }
 else
   return(FALSE);
}


BOOL OApp::QuitPosted() 
{
 return(FALSE); 
} 

BOOL OApp::TasklistKill() 
{
 return(FALSE); 
}


BOOL OApp::ShutdownPosted() 
{
 return(FALSE); 
}


// message loop

void OApp::run()
{
 BOOL dispatched;

 while(TRUE)
   {
    if (!WinGetMsg(hab, &qmsg, NULLHANDLE, 0, 0))
     {
      if (qmsg.hwnd == NULLHANDLE) {
        if (!ShutdownPosted()) return; }
      else if (qmsg.hwnd == HWNDFROMMP(qmsg.mp2)) {
        if (!TasklistKill()) return; }
      else if (!QuitPosted())
        return;
      else
        dispatched = TRUE;
     }
    else 
      dispatched = FALSE;

    if (!dispatched) 
      WinDispatchMsg(hab, &qmsg);    // default processing
   }
}

void OApp::forceQuit()
{
 WinPostMsg(NULLHANDLE, WM_QUIT, NULL, NULL);
}


pOCommandHandler OApp::NullHandler()
{
 return(&OCMD_NullHandler);
}


void OApp::Shutdown()
{
 WinShutdownSystem(hab, hmq);
}


void OApp::Reboot()
{
 HFILE  hf;
 ULONG  dummy;

 if (!DosOpen("DOS$", &hf, &dummy, 0L, FILE_NORMAL, FILE_OPEN,
              OPEN_ACCESS_WRITEONLY | OPEN_SHARE_DENYNONE | OPEN_FLAGS_FAIL_ON_ERROR, 0L))
  {
   ULONG ulParmLength = 0;
   ULONG ulDataLength = 0;

   WinBroadcastMsg(HWND_DESKTOP, WM_CLOSE, NULL, NULL, BMSG_SEND | BMSG_DESCENDANTS);
   SyncDisks();
   for (ULONG i = 0; i < 4; i++) {
     DosBeep(100, 100);
     DosSleep(1000); }
   DosBeep(100, 1000);
   DosShutdown(0L);
   DosDevIOCtl(hf, 0xd5, 0xab,           // Reboot
               NULL, 0L, &ulParmLength,
               NULL, 0L, &ulDataLength );
   DosClose( hf );
  }
}


// end of source
