// OCL - Class Library for OS/2 2.x and up
// (c) Benjamin Stein 1994
// All Rights Reserved
// OCircSlider.cpp

#include <OCL.HPP>
#include "OCircSlider.hpp"



OCircSlider::OCircSlider(const ULONG ID,
                         const HWND  Parent,
                         const ULONG scale,
                         const ULONG space,
                         const ULONG Style)
  : OWindow(ID, 0, 0),
    Scale(scale),
    Space(space)
{
 parent = Parent;
 owner  = Parent;
 style  = Style;
}



OCircSlider::OCircSlider(const OFrame& Parent,
                         const ULONG scale,
                         const ULONG space,
                         const ULONG Style)
  : OWindow(Parent.res, 0, 0),
    Scale(scale),
    Space(space)
{
 parent = Parent.hwnd;
 owner  = Parent.hwnd;
 style  = Style;
}


OCircSlider::OCircSlider(const pOFrame Parent,
                         const ULONG scale,
                         const ULONG space,
                         const ULONG Style)
  : OWindow(Parent->res, 0, 0),
    Scale(scale),
    Space(space)
{
 parent = Parent->hwnd;
 owner  = Parent->hwnd;
 style  = Style;
}



OCircSlider::~OCircSlider() {}



BOOL OCircSlider::createCircSlider(const SHORT x, const SHORT y,
                                   const SHORT cx, const SHORT cy)
{
 memset(&ctlData, 0, sizeof(CSBITMAPDATA));

#ifdef __OS2_30__
 if (!WinRegisterCircularSlider())
   return(FALSE);
#endif

 hwnd = WinCreateWindow(parent, WC_CIRCULARSLIDER, NULL, style | WS_VISIBLE,
                        x, y, cx, cy,
                        owner, HWND_TOP, 0, (PVOID)&ctlData, NULL);

 return (hwnd != NULLHANDLE);
}


// end of source
