// OCL - Class Library for OS/2 2.x and up
// (c) Benjamin Stein 1994
// All Rights Reserved
// OCreate.cpp


#define OINCL_OCREATE
#define OINCL_BASE
 
#include <ocl.hpp>


// member functions

OCreate::OCreate() : Created((HOBJECT)NULL) {}

OCreate::~OCreate() {}


void OCreate::Create()
{
 if (!File.text)
   return;
 
 if (!Location.text)
   Location << (PSZ) "<WP_DESKTOP>";

 
 if (is(".INF"))
   CreateBook();
 else if (is(".EXE") | is(".COM") |
           is(".BAT") | is(".CMD"))
   CreateExe();
 else
   CreateDoc();
 Title << (PSZ)NULL;
 File << (PSZ)NULL;
}


void OCreate::CreateBook()
{
 PSZ Setup = new CHAR[3*CCHMAXPATH];

 if (!Title.text)
  {
#ifndef __IBMCPP__
   ifstream file((PCSZ)File.text);
#else
   ifstream file(File.text);
#endif
   PSZ BTitle = new CHAR[50];
   BTitle[0] = '\0';
   file.seekg(107L);
   file.getline(BTitle, 48);
   if (strlen(BTitle) > 0)
     Title << BTitle;
   else
     Title << File.text;
   file.close();
   delete[] BTitle;
  }
 
 sprintf(Setup, "EXENAME=VIEW.EXE;PARAMETERS=%s", File.text);
 Created = WinCreateObject("WPProgram", Title.text,
                                    Setup, Location.text, CO_REPLACEIFEXISTS);
 delete[] Setup;
}


void OCreate::CreateExe()
{
 PSZ Setup = new CHAR[2*CCHMAXPATH];
 PSZ Dir     = new CHAR[CCHMAXPATH];

 File >> Dir;
 strcpy(strrchr(Dir, '\\'), "");

 if (!Title.text)
   Title << File.text;

 sprintf(Setup, "EXENAME=%s;STARTUPDIR=%s", File.text, Dir);
 Created = WinCreateObject("WPProgram", Title.text,
                                    Setup, Location.text, CO_REPLACEIFEXISTS);
 delete[] Setup;
 delete[] Dir;
}


void OCreate::CreateDoc()
{
 PSZ Setup = new CHAR[2*CCHMAXPATH];

 if (!Viewer.text)
   Viewer << (PSZ) "E.EXE";

 Title << (PSZ) "View:\n";
 Title + File.text;
 sprintf(Setup, "EXENAME=%s;PARAMETERS=\"%s\"", Viewer.text, File.text);
 Created = WinCreateObject("WPProgram", Title.text,
                                    Setup, Location.text, CO_REPLACEIFEXISTS);
 delete[] Setup;
}


BOOL OCreate::is(PCSZ Ext) 
{
 return(strstr(strupr(File.text), Ext)!=NULL); 
}


// end of source
