// OCL - Class Library for OS/2 2.x and up
// (c) Benjamin Stein 1994
// All Rights Reserved
// ODialog.cpp

// member functions of ODialog

#define INCL_WIN
#define INCL_PM

#define OINCL_ODIALOG

#include <ocl.hpp>


ODialog::ODialog(const ULONG idDlg)
  : OWindow(idDlg, 0, 0),
    module(NULLHANDLE)
{
 parent = HWND_DESKTOP;
 owner = HWND_DESKTOP;
}


ODialog::ODialog(const HWND Parent, const HWND Owner, const ULONG idDlg)
  : OWindow(idDlg, 0, 0),
    module(NULLHANDLE)
{
 parent = Parent;
 owner = Owner;
}


ODialog::ODialog(const HWND Parent, const HWND Owner, const HMODULE resource, const ULONG idDlg)
  : OWindow(idDlg, 0, 0),
    module(resource)
{
 parent = Parent;
 owner = Owner;
}


ODialog::~ODialog()
{
 destroyDlg();
}


void ODialog::createDlg()
{
 WinLoadDlg(parent, owner, OWinDefDlgProc, module, res, this);
}



void ODialog::showDlg()
{
 WinShowWindow(hwnd, TRUE);
}

void ODialog::hideDlg()
{
 WinShowWindow(hwnd, FALSE);
}


void ODialog::destroyDlg()
{
 WinDestroyWindow(hwnd);
}


void ODialog::centerDlg(const ULONG parent)
{
 SWP swpParent;
 SWP swp;

 switch(parent)
   {
    case CENTER_ONSCREEN:
      swpParent.cx=WinQuerySysValue(HWND_DESKTOP, SV_CXSCREEN);
      swpParent.cy=WinQuerySysValue(HWND_DESKTOP, SV_CYSCREEN);
      WinQueryWindowPos(hwnd, &swp);
      WinSetWindowPos(hwnd, HWND_TOP,
                     (swpParent.cx-swp.cx)/2,
                     (swpParent.cy-swp.cy)/2, 0, 0, SWP_MOVE);
      break;

    case CENTER_ONPARENT:
      WinQueryWindowPos(parent, &swpParent);
      WinQueryWindowPos(hwnd, &swp);
      WinSetWindowPos(hwnd, HWND_TOP,
                     (swpParent.cx-swp.cx)/2,
                     (swpParent.cy-swp.cy)/2, 0, 0, SWP_MOVE);
      break;
   }
}

// end of source
