// OCL - Class Library for OS/2 2.x and up
// (c) Benjamin Stein 1994
// All Rights Reserved
// OEditor.cpp


#define OINCL_OEDITOR
#define OINCL_OPMINIT

#include <ocl.hpp>


OEditor::OEditor(const ULONG id, const HWND Parent, const ULONG Style)
  : OMLE(id, Parent, Style),
    clearFlag(FALSE),
    loadFileThr(this, &OEditor::loadFile),
    saveFileThr(this, &OEditor::saveFile),
    saveFileAsThr(this, &OEditor::saveFileAs)
 {}


OEditor::OEditor(const pOFrame Parent,
                 const ULONG Style)
  : OMLE(Parent, Style),
    clearFlag(FALSE),
    loadFileThr(this, &OEditor::loadFile),
    saveFileThr(this, &OEditor::saveFile),
    saveFileAsThr(this, &OEditor::saveFileAs)
 {}


OEditor::OEditor(const OFrame& Parent,
                 const ULONG Style)
  : OMLE(Parent, Style),
    clearFlag(FALSE),
    loadFileThr(this, &OEditor::loadFile),
    saveFileThr(this, &OEditor::saveFile),
    saveFileAsThr(this, &OEditor::saveFileAs)
 {}



OEditor::~OEditor() {}


void OEditor::loadFile()
{
 FILEDLG  fdFileDlg;
 HWND     hwndFileDlg;

 memset(&fdFileDlg, 0, sizeof(FILEDLG));
 fdFileDlg.cbSize=sizeof(FILEDLG);
 fdFileDlg.fl=FDS_CENTER | FDS_OPEN_DIALOG;
 fdFileDlg.pszTitle="Editor";
 strcpy(fdFileDlg.szFullFile, "*");
 hwndFileDlg=WinFileDlg(HWND_DESKTOP, parent, &fdFileDlg);
 if (hwndFileDlg && (fdFileDlg.lReturn==DID_OK)) {
   deleteAll();
   insertFile(fdFileDlg.szFullFile); }
 openedFile << fdFileDlg.szFullFile;
}



void OEditor::saveFile()
{
 PBYTE      Buffer;
 HFILE      hf;
 ULONG      cbWritten, ulAction;
 ULONG      SIZE = 8192;

 if (!openedFile)
  {
   saveFileAs();
   return;
  }

 DosOpen(openedFile.text, &hf, &ulAction, 0, 0,
         OPEN_ACTION_CREATE_IF_NEW | OPEN_ACTION_OPEN_IF_EXISTS,
         OPEN_SHARE_DENYWRITE | OPEN_ACCESS_WRITEONLY,
         NULL);
 DosAllocMem((PPVOID)&Buffer, SIZE+1, PAG_READ | PAG_WRITE | PAG_COMMIT);

 imexOffset = 0;

 while(TRUE)
  {
   if((!(cbWritten = getText(Buffer, SIZE))) ||
        (DosWrite(hf, Buffer, cbWritten, &cbWritten)))
     break;
  }

 DosClose(hf);
 DosFreeMem(Buffer);
}



void OEditor::saveFileAs()
{
 FILEDLG  fdFileDlg;
 HWND     hwndFileDlg;

 memset(&fdFileDlg, 0, sizeof(FILEDLG));
 fdFileDlg.cbSize=sizeof(FILEDLG);
 fdFileDlg.fl=FDS_CENTER | FDS_SAVEAS_DIALOG;
 fdFileDlg.pszTitle="Editor";
 if (openedFile.text)
   strcpy(fdFileDlg.szFullFile, openedFile.text);
 hwndFileDlg=WinFileDlg(HWND_DESKTOP, parent, &fdFileDlg);
 if (hwndFileDlg && (fdFileDlg.lReturn==DID_OK))
  {
   openedFile << fdFileDlg.szFullFile;
   saveFileThr.run();
  }
}


// end of source
