// OCL - Class Library for OS/2 2.x and up
// (c) Benjamin Stein 1994
// All Rights Reserved
// OException.cpp


#include <ocl.hpp>
#include <OException.hpp>

OException::OException(const PSZ err,
                       const ULONG retcode,
                       const ULONG severity,
                       const PSZ source,
                       const ULONG line)
  : description(err),
    Source(source),
    Line(line),
    rc(retcode),
    state(severity)
  {}

OException::OException(const OString& err,
                       const ULONG retcode,
                       const ULONG severity,
                       const PSZ source,
                       const ULONG line)
  : description(err),
    Source(source),
    Line(line),
    rc(retcode),
    state(severity)
  {}


OException::OException(const OException& ex)
  : description(ex.description),
    Source(ex.Source),
    Line(ex.Line),
    rc(ex.rc)
  {}


OException::~OException() {}


// end of source
