// OCL - Class Library for OS/2 2.x and up
// (c) Benjamin Stein 1994
// All Rights Reserved
// OHelp.cpp

// help for PM applications


#define OINCL_OHELP

#include <ocl.hpp>


OHelp::OHelp(const ULONG mainTable, const ULONG errorID)
  : table(mainTable), 
    errid(errorID), 
    isHlpAvail(FALSE) 
  {}


OHelp::~OHelp() 
{
 terminateHelp(); 
}


void OHelp::terminateHelp()
{
 if (helpInstance) WinDestroyHelpInstance(helpInstance);
}


BOOL OHelp::initializeHelp(PCSZ helpLibrary, PCSZ title, const HWND associated)
{
 HELPINIT        HelpInit;

 if ((isHlpAvail) && (associated == assoc))
    return(TRUE);
 else
    assoc = associated;

 HelpInit.cb=sizeof(HELPINIT);
 HelpInit.ulReturnCode=0;
 HelpInit.pszTutorialName=(PSZ)NULL;
 HelpInit.phtHelpTable=(PHELPTABLE)MAKEULONG(table, 0xFFFF);
 HelpInit.hmodHelpTableModule=(HMODULE)0;
 HelpInit.hmodAccelActionBarModule=(HMODULE)0;
 HelpInit.idAccelTable=0;
 HelpInit.idActionBar=0;
 HelpInit.pszHelpWindowTitle = (PSZ) title;
 HelpInit.pszHelpLibraryName = (PSZ) helpLibrary;
 HelpInit.fShowPanelId=0;

 helpInstance = WinCreateHelpInstance(WinQueryAnchorBlock(associated), &HelpInit);
 if((!helpInstance) || (HelpInit.ulReturnCode)) {
   error(errid);
   return(FALSE); }

 isHlpAvail = (BOOL) WinAssociateHelpInstance(helpInstance, associated);
 if(!isHlpAvail) {
   error(errid);
   assoc = NULLHANDLE; }
 return(isHlpAvail);
}



BOOL OHelp::helpRequest(const ULONG id)
{
 if(!isHlpAvail) {
   error(errid);
   return(FALSE); }
 else
  {
   switch(id)
     {
      case help:
         WinSendMsg(helpInstance, HM_DISPLAY_HELP, NULL, NULL);
         break;

      case general:
         WinSendMsg(helpInstance, HM_GENERAL_HELP, NULL, NULL);
         break;

      case keys:
         WinSendMsg(helpInstance, HM_KEYS_HELP, NULL, NULL);
         break;

      case index:
         WinSendMsg(helpInstance, HM_HELP_INDEX, NULL, NULL);
         break;

      default:
         WinSendMsg(helpInstance, HM_DISPLAY_HELP, MPFROMSHORT(id), HM_RESOURCEID);
         break;
     }
   }
 return(TRUE);
}


// end of source
