// OCL - Class Library for OS/2 2.x and up
// (c) Benjamin Stein 1994
// All Rights Reserved
// .cpp


#define OINCL_OAPP
#define OINCL_OICON
#define OINCL_OPMEXCEPTION

#include <ocl.hpp>



OIcon::OIcon()
  : hptr(NULLHANDLE)
  {}


OIcon::OIcon(const ULONG resID, const HMODULE module)
  : hptr(WinLoadPointer(HWND_DESKTOP, module, resID))
{
 if (!hptr)
   throw OPMException((PSZ)NULL, 0, OException::recoverable);
}



OIcon::OIcon(const HPOINTER ptrHandle)
  : hptr(ptrHandle)
  {}


OIcon::OIcon(PCSZ fileName)
  : hptr(WinLoadFileIcon(fileName, TRUE))
{
 if (!hptr)
   throw OPMException((PSZ)NULL, 0, OException::recoverable);
}


OIcon::~OIcon()
{
 if (hptr)
   WinDestroyPointer(hptr);
}


// end of source
