// OCL - Class Library for OS/2 2.x and up
// (c) Benjamin Stein 1994
// All Rights Reserved
// OLogo.cpp


#define INCL_WIN
#define INCL_PM
#define OINCL_OLOGO
#define OINCL_OPMEXCEPTION


#include <ocl.hpp>


OLogo::OLogo(const HMODULE module, const ULONG bitmapID, const ULONG cx, const ULONG cy)
  : OFrame(bitmapID, 0, CS_SIZEREDRAW),
    bmp(NULL),
    mod(module)
{
 sizepos.cx = cx;
 sizepos.cy = cy;
 sizepos.x = (WinQuerySysValue(HWND_DESKTOP, SV_CXSCREEN)-cx)/2;
 sizepos.y = (WinQuerySysValue(HWND_DESKTOP, SV_CYSCREEN)-cy)/2;
 dest.x = 0;
 dest.y = 0;
}


OLogo::OLogo(const PSZ filename, const ULONG frameID, const ULONG cx, const ULONG cy)
  : OFrame(frameID, 0, CS_SIZEREDRAW),
    bmp(NULL),
    bmpfile((PSZ)filename),
    mod(NULLHANDLE)
{
 sizepos.cx = cx;
 sizepos.cy = cy;
 sizepos.x = (WinQuerySysValue(HWND_DESKTOP, SV_CXSCREEN)-cx)/2;
 sizepos.y = (WinQuerySysValue(HWND_DESKTOP, SV_CYSCREEN)-cy)/2;
 dest.x = 0;
 dest.y = 0;
}


OLogo::~OLogo() 
{
 if (bmp) delete bmp;
}


BOOL OLogo::showLogo(const ULONG timeout)
{
 if (createFrame("OCL Logo")) {
   if (timeout != 0) {
     DosSleep(timeout);
     destroyFrame(); }
   return(TRUE); }
 return(FALSE);
}


BOOL OLogo::OCommand(ULONG msg, MPARAM mp1, MPARAM mp2)
{
 switch(msg)
   {
    case WM_CREATE:
      WinSetWindowPos(frame, HWND_BOTTOM, sizepos.x, sizepos.y,
                      sizepos.cx, sizepos.cy,
                      SWP_MOVE | SWP_SIZE | SWP_SHOW);
      try
       {
        if (bmpfile.text)
          bmp = new OBitmap(hwnd, bmpfile.text);
        else
          bmp = new OBitmap(hwnd, res, mod);
       }
      catch(OPMException &ex)
       {
        bmp = NULL;
        ex.viewError();
        return(TRUE);
       }
      hps = WinGetPS(hwnd);
      WinDrawBitmap(hps, bmp->hbm, NULL, &dest, 0L, 0L, DBM_IMAGEATTRS);
      break;

    case WM_ERASEBACKGROUND:
      dest.x = 0;
      dest.y = 0;
      if (bmp)
        WinDrawBitmap(hps, bmp->hbm, NULL, &dest, 0L, 0L, DBM_IMAGEATTRS);
      return(TRUE);

    case WM_CLOSE:
    case WM_DESTROY:
      WinReleasePS(hps);
      break;

    default:
      return(FALSE);
   }
 return(TRUE);
#ifdef __BCPLUSPLUS__
  #pragma warn -par
#endif
}
#ifdef __BCPLUSPLUS__
  #pragma warn .par
#endif

// end of source
