// OCL - Class Library for OS/2 2.x and up
// (c) Benjamin Stein 1994
// All Rights Reserved
// OMsgs.cpp

#define INCL_WIN
#define INCL_PM
#define OINCL_OMSGS

#include <ocl.hpp>



OMsgs::OMsgs(const HMODULE moduleHandle)
{
 handle = moduleHandle;
}


OMsgs::~OMsgs() {}


void OMsgs::setResource(const HMODULE moduleHandle)
{
 handle = moduleHandle; 
}


void OMsgs::info(const ULONG msgID)
{
 if (loadString(msgID, 2*CCHMAXPATH, Msg))
   info("Information", Msg);
}


void OMsgs::info(const ULONG titleID, const ULONG msgID)
{
 if ((loadString(msgID, 2*CCHMAXPATH, Msg)) && (loadString(titleID, 60, Title)))
   info(Title, Msg);
}


void OMsgs::info(PCSZ msg)
{
 info("Information", msg);
}


void OMsgs::info(PCSZ title, PCSZ msg)
{
 WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, (PCH) msg, (PCH) title, 0,
               MB_OK | MB_MOVEABLE | MB_INFORMATION);
}


void OMsgs::error(const ULONG msgID)
{
 if (loadString(msgID, 2*CCHMAXPATH, Msg))
   error("Error", Msg);
}

void OMsgs::error(const ULONG titleID, const ULONG msgID)
{
 if ((loadString(msgID, 2*CCHMAXPATH, Msg)) && (loadString(titleID, 60, Title)))
   error(Title, Msg);
}


void OMsgs::error(PCSZ msg)
{
 error("Error", msg);
}


void OMsgs::error(PCSZ title, PCSZ msg)
{
 beeper();
 WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, (PCH) msg, (PCH) title, 0,
               MB_APPLMODAL | MB_OK | MB_MOVEABLE | MB_CUAWARNING);
}


BOOL OMsgs::ask(const ULONG titleID, const ULONG msgID)
{
 if ((loadString(msgID, 2*CCHMAXPATH, Msg)) && (loadString(titleID, 60, Title)))
   return(ask(Title, Msg));
 else
   return(FALSE);
}


BOOL OMsgs::ask(PCSZ title, PCSZ msg)
{
 return(WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, (PCSZ)msg, (PCSZ)title,
          0, MB_APPLMODAL | MB_YESNO | MB_ICONQUESTION | MB_DEFBUTTON1)==MBID_YES);
}



BOOL OMsgs::loadString(const ULONG resID, const ULONG Size, PSZ str)
{
 if (!OApp::currentOApp)
   return(FALSE);
 return(WinLoadString(OApp::currentOApp->hab, handle, resID, Size, str)!=0);
}


void OMsgs::beeper()
{
 DosBeep(100, 100);
 DosBeep(200, 100);
 DosBeep(300, 100);
}

// end of source
