// OCL - Class Library for OS/2 2.x and up
// (c) Benjamin Stein 1994
// All Rights Reserved
// OPMTool.cpp

// some utiliy functions for PM

#define INCL_DOS
#include <ocl.hpp>


// Enable/Disable DialogItems

VOID __CPP_EXPORT__ DisableDialogItem(HWND hwnd, USHORT usDialogIDs[], USHORT usItemCount, ULONG ulStyle)
{
USHORT  usTemp;

if(ulStyle&WS_DISABLED)
    for(usTemp=0; usTemp<usItemCount; usTemp++)
       WinEnableWindow(WinWindowFromID(hwnd, usDialogIDs[usTemp]), FALSE);
else
    for(usTemp=0; usTemp<usItemCount; usTemp++)
       WinEnableWindow(WinWindowFromID(hwnd, usDialogIDs[usTemp]), TRUE);
if(ulStyle&WS_VISIBLE)
    for(usTemp=0; usTemp<usItemCount; usTemp++)
       WinSetWindowPos(WinWindowFromID(hwnd, usDialogIDs[usTemp]), 0, 0, 0, 0, 0, SWP_SHOW);
else
    for(usTemp=0; usTemp<usItemCount; usTemp++)
       WinSetWindowPos(WinWindowFromID(hwnd, usDialogIDs[usTemp]), 0, 0, 0, 0, 0, SWP_HIDE);
return;
}



// DialogItem unsichtbar machen


VOID __CPP_EXPORT__ HideDialogItem(HWND hwnd, USHORT usDialogIDs[], USHORT usItemCount)
{
 USHORT  usTemp;

 for(usTemp=0; usTemp<usItemCount; usTemp++)
   WinSetWindowPos(WinWindowFromID(hwnd, usDialogIDs[usTemp]), 0, 0, 0, 0, 0, SWP_HIDE);
 return;
}


// DialogItem sichtbar machen

VOID __CPP_EXPORT__ ShowDialogItem(HWND hwnd, USHORT usDialogIDs[], USHORT usItemCount)
{
 USHORT  usTemp;

 for(usTemp=0; usTemp<usItemCount; usTemp++)
   WinSetWindowPos(WinWindowFromID(hwnd, usDialogIDs[usTemp]), 0, 0, 0, 0, 0, SWP_SHOW);
 return;
}


// Desktop-ID wiederherstellen

BOOL __CPP_EXPORT__ SaveID(PCH DESK)
{
 HOBJECT hObject;

 hObject=WinQueryObject((PCH) DESK);
 if (hObject==NULLHANDLE)
   return(FALSE);
 if ((WinSetObjectData(hObject, "OBJECTID=<WP_DESKTOP>")==TRUE))
   return(TRUE);
 else
   return(FALSE);
}


void __CPP_EXPORT__ disableControls(HWND hwnd, USHORT usDialogIDs[], ULONG count)
{
 DisableDialogItem(hwnd, usDialogIDs, count/sizeof(USHORT), WS_VISIBLE | WS_DISABLED);
}

void __CPP_EXPORT__ enableControls(HWND hwnd, USHORT usDialogIDs[], ULONG count)
{
 DisableDialogItem(hwnd, usDialogIDs, count/sizeof(USHORT), WS_VISIBLE | 0);
}

void __CPP_EXPORT__ hideControls(HWND hwnd, USHORT usDialogIDs[], ULONG count)
{
 HideDialogItem(hwnd, usDialogIDs, count/sizeof(USHORT));
}

void __CPP_EXPORT__ showControls(HWND hwnd, USHORT usDialogIDs[], ULONG count)
{
 ShowDialogItem(hwnd, usDialogIDs, count/sizeof(USHORT));
}


APIRET __CPP_EXPORT__ StartSession(STARTDATA *SessionData)
{
 ULONG       SessID;
 PID            Pid;
 CHAR         ObjBuf[100];
 APIRET       rc;
 STARTDATA StartData;

 memset(&StartData, 0, sizeof(StartData));

 StartData.Length = sizeof(STARTDATA);
 if (SessionData->Related == 0)
    StartData.Related = SSF_RELATED_INDEPENDENT;
 else
    StartData.Related = SessionData->Related;
 if (SessionData->FgBg == 0)
    StartData.FgBg = SSF_FGBG_FORE;
 else
    StartData.FgBg = SessionData->FgBg;
 StartData.TraceOpt = SSF_TRACEOPT_NONE;
 StartData.PgmTitle = SessionData->PgmTitle;
 StartData.PgmName = SessionData->PgmName;
 StartData.TermQ = 0;
 StartData.Environment = 0;
 StartData.InheritOpt = SSF_INHERTOPT_PARENT;
 if (SessionData->SessionType == 0)
    StartData.SessionType = SSF_TYPE_DEFAULT;
 else
    StartData.SessionType = SessionData->SessionType;
 StartData.IconFile = 0;
 StartData.PgmHandle = 0;
 if (SessionData->PgmControl == 0)
    StartData.PgmControl = SSF_CONTROL_VISIBLE;
 else
    StartData.PgmControl = SessionData -> PgmControl;
 StartData.InitXPos = 50;
 StartData.InitYPos = 50;
 StartData.InitXSize = 400;
 StartData.InitYSize = 400;
 StartData.Reserved = 0;
 StartData.ObjectBuffer = ObjBuf;
 StartData.ObjectBuffLen = 100;
 StartData.PgmInputs = SessionData->PgmInputs;

 rc = DosStartSession(&StartData, &SessID, &Pid);

 return (APIRET) rc;
}

// end of source
