// OCL - Class Library for OS/2 2.x and up
// (c) 1994 Matthias Stbner
// All Rights Reserved
// OSpinBtn.cpp

#define OINCL_BASE

#include <OCL.HPP>
#include "OSpinBtn.hpp"


OSpinBtn::OSpinBtn(const ULONG ID,
                   const HWND  Parent,  // becomes parent and owner of the slider
                   const ULONG Style)
  : OWindow(ID, 0, 0)
{
 style  = Style;
 parent = Parent;
 owner  = Parent;
}


OSpinBtn::OSpinBtn(const OFrame& Parent,
                   const ULONG Style)
  : OWindow(Parent.res, 0, 0)
{
 style  = Style;
 parent = Parent.hwnd;
 owner  = Parent.hwnd;
}


OSpinBtn::OSpinBtn(const pOFrame Parent,
                   const ULONG Style)
 : OWindow(Parent->res, 0, 0)
{
 style  = Style;
 parent = Parent->hwnd;
 owner  = Parent->hwnd;
}

// dtor

OSpinBtn::~OSpinBtn() {}


BOOL OSpinBtn::createSpinBtn(const SHORT x, const SHORT y, 
                             const SHORT cx, const SHORT cy)
{
 hwnd = WinCreateWindow(parent, WC_SPINBUTTON, NULL, style | WS_VISIBLE,
                        x, y, cx, cy,
                        owner, HWND_TOP, 0, NULL, NULL);

 return(hwnd != NULLHANDLE);
}


BOOL OSpinBtn::setArray(PSZ array, ULONG num)
{
  return((BOOL)WinSendMsg (hwnd, SPBM_SETARRAY,
                     MPFROMP (array),
                     MPFROMLONG (num)));
}

BOOL OSpinBtn::setCurrent(LONG index)
{
  return((BOOL)WinSendMsg (hwnd, SPBM_SETCURRENTVALUE,
                     MPFROMLONG(index),0));
}

BOOL OSpinBtn::setLimits(LONG upper, LONG lower)
{
  return((BOOL)WinSendMsg (hwnd, SPBM_SETLIMITS,
                     MPFROMLONG(upper),
                     MPFROMLONG(lower)));
}

BOOL OSpinBtn::setMaster(HWND master)
{
  return((BOOL)WinSendMsg (hwnd, SPBM_SETMASTER,
                     MPFROMP(master),0));
}

BOOL OSpinBtn::setTextLimit(USHORT length)
{
  return((BOOL)WinSendMsg (hwnd, SPBM_SETTEXTLIMIT,
                     MPFROMSHORT(length),0));
}

BOOL OSpinBtn::OverrideLimits(LONG upper, LONG lower)
{
  return((BOOL)WinSendMsg (hwnd, SPBM_OVERRIDESETLIMITS,
                     MPFROMLONG(upper),
                     MPFROMLONG(lower)));
}

BOOL OSpinBtn::incSpin(ULONG delta)
{
  return((BOOL)WinSendMsg (hwnd, SPBM_SPINUP,
                     MPFROMLONG(delta),0));
}

BOOL OSpinBtn::decSpin(ULONG delta)
{
  return((BOOL)WinSendMsg (hwnd, SPBM_SPINDOWN,
                     MPFROMLONG(delta),0));
}

BOOL OSpinBtn::getLimits(LONG *upper, LONG *lower)
{
  return((BOOL)WinSendMsg(hwnd,SPBM_QUERYLIMITS,
                     MPFROMP(upper),MPFROMP(lower)));
}

BOOL OSpinBtn::getCurrent(PVOID addr, USHORT size, USHORT control)
{
  return((BOOL)WinSendMsg (hwnd, SPBM_QUERYVALUE,
                     MPFROMP(addr),
                     MPFROM2SHORT(size,control)));
}

BOOL OSpinBtn::jumptoEnd()
{
  while(WinSendMsg(hwnd,SPBM_SPINUP,MPFROMLONG(1),0)) {}
  return(TRUE);
}

BOOL OSpinBtn::jumptoStart()
{
  while(WinSendMsg(hwnd,SPBM_SPINDOWN,MPFROMLONG(1),0)) {}
  return(TRUE);
}















