// OCL - Class Library for OS/2 2.x and up
// (c) Benjamin Stein 1994
// All Rights Reserved
// OString.cpp


// class member functions


#define OINCL_OSTRING
#define OINCL_BASE


#include <ocl.hpp>


PSZ OString::getText() 
{
 return  text; 
}


OString::OString()
{ 
 text = NULL; 
}

OString::OString(const PSZ iText)
{
 if (iText) {
   text = new CHAR[strlen(iText)+1];
   strcpy(text, iText); }
 else
   text = NULL;
}

OString::OString(const OString& String)
{
 if (String.text) {
   text = new CHAR[strlen(String.text)+1];
   strcpy(text, String.text); }
}


OString::OString(const pOString String)
{
 if ((String) && (String->text)) {
   text = new CHAR[strlen(String->text)+1];
   strcpy(text, String->text); }
}


OString::OString(int iLength)
{
 text = new char[iLength+1]; 
}

OString::~OString() 
{
 delete[] text;
 text = NULL; 
}


OString& OString::operator << (OString& string)
{ 
 return(*this << string.text);
}


OString& OString::operator << (pOString string)
{ 
 if ((string) && (string->text)) 
   return(*this << string->text);
 else
   return(*this);
}



OString& OString::operator + (OString& string)
{ 
 return(*this + string.text);
}


OString& OString::operator + (pOString string)
{ 
 if ((string) && (string->text)) 
   return(*this + string->text);
 else
   return(*this);
}


OString& OString::operator << (PSZ string) 
{    // set or replace the string
 if (text) {
   delete[] text;
   text = NULL; }
 if (string) {
   text = new CHAR[strlen(string)+1];
   strcpy(text, string); }
 return(*this);
}

void OString::operator >> (PSZ string) 
{    // get a copy of text into String
 if (string) strcpy(string, text); 
}


OString& OString::operator + (PSZ string) 
{     // add String to the end of text
 if ((text) && (string)) {
   PSZ tmp = new CHAR[strlen(text)+strlen(string)+1];

   strcpy(tmp, text);
   strcat(tmp, string);
   *this << tmp;
   delete[] tmp; }
 return(*this);
}

OString& OString::operator - (int Letter) 
{     // add String to the end of text
 if (text) {
   PSZ tmp;

   strcpy(strrchr(text, Letter), "");
   tmp = new CHAR[strlen(text)+1];
   strcpy(tmp, text);
   delete[] text;
   text = tmp; }
 return(*this);
}


int OString::operator == (const OString& anOther)const
{
 return (strcmp(text, anOther.text) == 0); 
}


int OString::operator == (PSZ anOther)const 
{
 return (strcmp(text, anOther) == 0); 
}


int OString::operator != (const OString& anOther)const 
{
 return !(*this == anOther); 
}


int OString::operator < (const OString& anOther)const 
{
 return (strcmp(text, anOther.text) < 0); 
}


int OString::operator > (const OString& anOther)const 
{
 return (strcmp(text, anOther.text) > 0); 
}


int OString::operator <= (const OString& anOther)const 
{
 return !(*this > anOther); 
}


int OString::operator >= (const OString& anOther)const 
{
 return !(*this < anOther); 
}


OString& OString::operator = (const OString& iString) 
{
 if (& iString == this)
   return  *this;
 delete[] text;
 text = strdup(iString.text);
 return  *this; 
}


int OString::compare (OString&  s1, OString& s2)
{
 return strcmp(s1.getText(),s2.getText());
}



BOOL OString::operator ! ()const
{
 return(text == NULL);
}


ostream& operator<< (ostream& out, OString& s)
{
 return((s.text != NULL) ? (out << s.text) : out);
}


istream& operator>> (istream& in, OString& s)
{
 PSZ Buf = new CHAR[CCHMAXPATH];

 in >> Buf;
 s << Buf;
 delete[] Buf;
 return(in);
}


// end of source
