// OCL - Class Library for OS/2 2.x and up
// (c) Benjamin Stein 1994
// All Rights Reserved
// OThreadBase.cpp
// asynchronous threads


#define OINCL_OTHREAD
#include <ocl.hpp>



OThreadBase::OThreadBase(ULONG stackSize, BOOL forPM)
 : initPM(forPM),
   stack(stackSize), 
   tid(0)
 {}


OThreadBase::~OThreadBase()
{
 stop();
}


BOOL OThreadBase::run()                              // start thread
{
 if (isRunning())
   return(FALSE);
#ifdef __BCPLUSPLUS__
 tid = _beginthread((PFNTHREAD)OTHREADBASE_dispatch, stack, this);
#else
 tid = _beginthread((PFNTHREAD)OTHREADBASE_dispatch, NULL, stack, this);
#endif
 return(tid != 0);
}


BOOL OThreadBase::isRunning()
{
 if (tid != 0)
   return(DosWaitThread(&tid, DCWW_NOWAIT) == ERROR_THREAD_NOT_TERMINATED);
 else return(FALSE);
}


BOOL OThreadBase::waitFor()
{
 if (tid != 0)
   return(DosWaitThread(&tid, DCWW_WAIT) != ERROR_THREAD_NOT_TERMINATED);
 else return(FALSE);
}


void OThreadBase::setPrty(ULONG Class, ULONG Delta)
{
 if (isRunning())
   DosSetPriority(PRTYS_THREAD, Class, Delta, tid);
}


void OThreadBase::stop()
{
 if (isRunning())
   DosKillThread(tid); 
}


void OThreadBase::suspend()
{
 if (isRunning())
   DosSuspendThread(tid);
}


void OThreadBase::resume()
{
 if (isRunning())
   DosResumeThread(tid);
}


void OThreadBase::OTHREADBASE_dispatch(PVOID pvData)
{
 pOThreadBase thread = (pOThreadBase) pvData;
 pOPMinit     init   = NULL;

 if (!thread)
   _endthread();

 if (thread->initPM)
   init = new OPMinit;

 thread->async();

 if ((thread->initPM) && (init))
   delete init;

 thread->tid = 0;
 _endthread();
}



// end of source
