// OCL - Class Library for OS/2 2.x and up
// (c) Benjamin Stein 1994
// All Rights Reserved
// OVioException.cpp


#define OINCL_OVIOEXCEPTION
#include <ocl.hpp>


OVioException::OVioException(const PSZ err,
                             const ULONG retcode,
                             const ULONG severity,
                             const PSZ source,
                             const ULONG line)
  : OException(err, retcode, severity, source, line)
  {}

OVioException::OVioException(const OString& err,
                             const ULONG retcode,
                             const ULONG severity,
                             const PSZ source,
                             const ULONG line)
  : OException(err, retcode, severity, source, line)
  {}


OVioException::OVioException(const OVioException& ex)
  : OException(ex.description.text, ex.rc, ex.state, ex.Source.text, ex.Line)
  {}


OVioException::~OVioException() {}


void OVioException::viewError()
{
 CHAR   ErrBuffer[512];

 sprintf(ErrBuffer,
        "An Exception was thrown in Module: %s\nLinenumber in Sourcecode: %d\n"\
        "RetCode: %d\nError reported: ",
        Source.text, Line, rc);

 if (!description) 
  description << "No description available.";
 strcat(ErrBuffer, description.text);
 cerr << ErrBuffer;
}




// end of source
